# syntax=docker-registry.wikimedia.org/repos/releng/blubber/buildkit:v0.19.0

version: v4

builders:
  - python:
      version: python3

variants:

  base:
    base: docker-registry.wikimedia.org/python3-bullseye:0.0.2-20230528
    copies: [local]

  lint:
    includes: [base]
    builders:
      - python:
          requirements:
            - lint-requirements.txt
    # Allow imports not at the top of file (needed when modifying sys.path) and lines longer than 79 chars
    entrypoint: [flake8, '--extend-ignore=E402,E501']

  test:
    includes: [base]
    builders:
      - python:
          requirements:
            - requirements.txt
            - test-requirements.txt
    runs:
      # So pytest can write its cache
      insecurely: True
    entrypoint: [pytest, -v]

  docpub:
    includes: [base]
    apt:
      packages:
        - rsync
    builders:
      - python:
          requirements:
            - requirements.txt
      - custom:
          requirements:
            - from: local
              source: bin/docpub.py
              destination: /usr/local/bin/docpub.py
          command: [chmod, "0755", /usr/local/bin/docpub.py]
      - custom:
          requirements:
            - from: local
              source: bin/trigger_docpub.py
              destination: /usr/local/bin/trigger_docpub.py
          command: [chmod, "0755", /usr/local/bin/trigger_docpub.py]
